unit hiLCD_LPT;

interface

uses Kol,Share,Windows,Debug;

///         DLL ////////////////////////////
  function Out32(PortAdrOut: word; Data: byte): byte; stdcall; external 'inpout32.dll';//
  function Inp32(PortAdrOut: word): byte; stdcall; external 'inpout32.dll';            //
//////////////////////////////////////////////////////////////////////////////////////
type //   
 THILCD_LPT = class(TDebug)
private                            //     ,       
   PortAdr:word;                   //    (888,632,956)
   LCD_CR:byte;             //    
public   //   //              //     InlineCode
     
	 _event_onEND:THI_Event; //  
     _data_DataReg:THI_Event;
     _data_DataChar:THI_Event;
      
      procedure _work_doIniLCD(var _Data:TData; Index:word); 
      procedure _work_doSendChar(var _Data:TData; Index:word);
      procedure _work_doSendReg(var _Data:TData; Index:word);
      procedure SendChar(X:byte); //   
      procedure SendReg(X:byte);  //     (.)        
      procedure SleepMks(mks:integer);
	  	    
      property _prop_Port:word write PortAdr;
 
 end;
//******************************************************************************
               implementation                                         
//******************************************************************************

////////////////////////////////////////////////////////////////////////////////
///   
////////////////////////////////////////////////////////////////////////////////
procedure THILCD_LPT._work_doSendChar; //                
var i:integer;
begin                                              
    i := ReadInteger(_Data,_data_DataChar);// 
	SendChar(i);
end;              
////////////////////////////////////////////////////////////////////////////////
///     
////////////////////////////////////////////////////////////////////////////////
procedure THILCD_LPT._work_doSendReg; //                
var  i:integer;
begin                                              
    i := ReadInteger(_Data,_data_DataReg);//
	SendReg(i);//        
end;              
////////////////////////////////////////////////////////////////////////////////
///  
////////////////////////////////////////////////////////////////////////////////
procedure THILCD_LPT._work_doIniLCD;                 //     Port+0
var i:integer;
begin   //     0
/////////////MessageBox(0,' ','!!!',MB_OK+MB_ICONERROR);
LCD_CR := 11 ;//    
SleepMks(4100);

Out32(PortAdr+2,LCD_CR);// 
SendReg($30);//     
SleepMks(4100);
SendReg($30);//     
SleepMks(100);
SendReg($30);//     
SleepMks(100);
SendReg($38);//     
SleepMks(100);
SendReg($0C);//      - ,   .
SleepMks(100);  
SendReg($01);//  
SleepMks(100);
SendReg($06);//       
SleepMks(100);
end;                                                 
//================  =========================================================
procedure THILCD_LPT.SendReg; //                   

begin                                              
    LCD_CR := LCD_CR and not (1shl 2);//  RS  3
	Out32(PortAdr+2,LCD_CR);// 
	
	LCD_CR := LCD_CR and not (1shl 0);//   0 ()
	Out32(PortAdr+2,LCD_CR);// 
   
	Out32(PortAdr,X);//   
     SleepMks(50);

	LCD_CR := LCD_CR or (1shl 0);//   0 ()
	Out32(PortAdr+2,LCD_CR);// 
	 SleepMks(50);
	Out32(PortAdr,255);//   
    
	_hi_OnEvent(_event_onEND,X);//   
end;
//================  =======================================================                                                 
procedure THILCD_LPT.SendChar; //                   

begin                                              
    LCD_CR := LCD_CR or (1shl 2);//  RS  3
	Out32(PortAdr+2,LCD_CR);// 
    
	LCD_CR := LCD_CR and not (1shl 0);//   0 ()
	Out32(PortAdr+2,LCD_CR);// 
  
	Out32(PortAdr,X);//   
    SleepMks(50);
	LCD_CR := LCD_CR or (1shl 0);//   0 ()
	Out32(PortAdr+2,LCD_CR);// 
	 SleepMks(50);
	Out32(PortAdr,255);//  
    
	_hi_OnEvent(_event_onEND,X);//   
   
end;
//=================  =======================================================                                                 
procedure THILCD_LPT.SleepMks;
var sp,ep,cnt:int64;
begin
   QueryPerformanceCounter(sp);
   QueryPerformanceFrequency(cnt);
   cnt := cnt div 1000000;
   repeat
     QueryPerformanceCounter(ep);
   until (ep - sp)div cnt > mks;
  
end;




end.
